;Wrappers functions provided for come file/directory/volume operations
;Author: Shantanu Gadgil
; check out the FS_CreateDirectoryEx function in particular!!!
; -Enjoy!

.386
.model flat,stdcall
option casemap:none

include windows.inc

include kernel32.inc

include FileSystem.inc

.code
;FS_IsDirectory
;	checks if a specified path is actually a directory
;	returns TRUE or FALSE (du-uh!!!)
FS_IsDirectory	proc	pszPath:LPCTSTR
	invoke	GetFileAttributes,pszPath
	
	.if	eax == 0ffffffffh	;INVALID_FILE_ATTRIBUTES
		ret	;return with the ERROR
	.endif
	
	test	eax,FILE_ATTRIBUTE_DIRECTORY
	.if	zero?	;not directory
		mov	eax, FALSE
		ret
	.endif
	
	mov	eax, TRUE
	ret
FS_IsDirectory endp

;FS_GetVolumeName
;	gives ONLY the volume name (if ONLY that is what is required :) 
;	check function "FS_GetVolumeInfo" which retrieves ALL the info in a nice little structure
FS_GetVolumeName	proc	pszPath:LPCTSTR, pszVolume:LPTSTR
	LOCAL	dwUnused1:DWORD
	LOCAL	dwUnused2:DWORD
	LOCAL	dwUnused3:DWORD
	LOCAL	szUnused[32]:BYTE
	
	invoke	GetVolumeInformation,pszPath,pszVolume,32,addr dwUnused1,addr dwUnused2,addr dwUnused3,addr szUnused,32
	
	ret
FS_GetVolumeName	endp

;FS_MakeParent
;	chops off the last entry from a path;
;	"X:\dir1\dir2\final',0	would become "X:\dir1\dir2",0 
FS_MakeParent	proc	pszPath:LPTSTR
	push	esi
	push	ebx
	push	ecx	;counter
	
	xor	ecx, ecx
	mov	esi,pszPath
	.while	byte ptr [esi] != 0
		.if	byte ptr [esi] == '\'
			inc	ecx
			mov	ebx, esi
		.endif
		inc	esi
	.endw
	
	.if	ecx > 0
		mov	byte ptr [ebx], 0
	.endif
	
	pop	ecx
	pop	ebx
	pop	esi
	ret
FS_MakeParent	endp

;FS_GetVolumeInfo
;	returns the various volume info strings in a nice little structure
;	the Windows API returns all of them in separate strings :( :(
FS_GetVolumeInfo	proc	pVolumeInfo:LPFSVOLUMEINFOSTRUCT
	mov	ebx,pVolumeInfo
	
	invoke	GetVolumeInformation, addr FSVOLUMEINFOSTRUCT.szRootPath[ebx],
			addr FSVOLUMEINFOSTRUCT.szVolumeName[ebx],
			FS_MAX_VOLUME_NAME,
			addr FSVOLUMEINFOSTRUCT.dwVolumeSerialNumber[ebx],
			addr FSVOLUMEINFOSTRUCT.dwMaximumComponentLength[ebx],
			addr FSVOLUMEINFOSTRUCT.dwFileSystemFlags[ebx],
			addr FSVOLUMEINFOSTRUCT.szFileSystemNameBuffer[ebx],
			FS_MAX_FS_NAME
	ret
FS_GetVolumeInfo	endp

;pretty redundant function...quite pointless
;could use "wsprintf" at the point of call
;coded this incase the SADD macro is not available :):)
FS_MakeFullFilePath	proc	pszDirName:LPCTSTR, pszFileName:LPCTSTR, pszFullFileName:LPTSTR
	invoke	lstrcpy,pszFullFileName,pszDirName
	invoke	FS_AddTrailingBackSlash,pszFullFileName,FALSE
	invoke	lstrcat,pszFullFileName,pszFileName
	ret
FS_MakeFullFilePath endp

;adds a trailing backslash with checking condition for REPEAT
FS_AddTrailingBackSlash	proc	pszString:LPTSTR, bAllowRepeat:BOOL
	push	ecx
	push	esi
	
	mov	esi,pszString
	
	xor	ecx,ecx	;counter
	
	.while	byte ptr [esi] != 0
		inc	esi
		inc	ecx
	.endw
	
	mov	eax, TRUE	;backslash is GOING TO BE added, by default
	
	.if	bAllowRepeat == TRUE
		;add one even EVEN IF IT already exists
		;implies just adding a backslash
	.elseif	bAllowRepeat == FALSE
		.if	ecx > 0		;string-length > 0
			dec	esi	;move 1 char back
		.endif
		
		.if	byte ptr [esi] == '\'
			;last char already '\' nothing to do
			mov	eax, FALSE
		.else
			inc	esi
		.endif
	.endif
	mov	byte ptr [esi],'\'
	mov	byte ptr [esi+1],0

	pop	esi
	pop	ecx
	ret
FS_AddTrailingBackSlash	endp

;removes the trailing backslash IF it exists :)
FS_RemoveTrailingBackSlash	proc	pszString:LPTSTR
	push	ecx
	push	esi
	
	mov	eax,FALSE	;there is NO trailing backslash by default :)
	
	xor	ecx, ecx
	mov	esi,pszString
	.while	byte ptr [esi] != 0
		inc	esi
		inc	ecx
	.endw
	
	.if	ecx > 0
		dec	esi
		.if	byte ptr [esi] == '\'
			mov	byte ptr [esi],0
			mov	eax,TRUE
		.endif
	.endif
		
	pop	esi
	pop	ecx
	ret
FS_RemoveTrailingBackSlash endp

;path checked if it is ROOT. Valid strings: 'X:' and 'X:\'
FS_IsPathRoot	proc	pszPath:LPTSTR
	LOCAL	dwReturnValue:DWORD
	
	push	esi
	
	mov	dwReturnValue, TRUE
	
	mov	esi,pszPath
	
	mov	al, [esi]
	or	al, 32	;make small-case :), assuming valid letter ([A-Z] or [a-z])
	
	;check first character to be a valid ALPHABET
	.if	al < 'a' || al > 'z'
		mov	dwReturnValue, FALSE
		jmp	@f
	.endif
	
	;check second character for ':' :D :)
	.if	byte ptr [esi+1] != ':'
		mov	dwReturnValue, FALSE
		jmp	@f
	.endif
	
	;now, two possible conditions; a backslash or NOT
	.if	byte ptr [esi+2] == '\' && byte ptr [esi+3] == 0
		;fine, no probs
	.elseif	byte ptr [esi+2] == 0
		;fine, no probs
	.else
		mov	dwReturnValue, FALSE
	.endif
@@:	
	pop	esi
	mov	eax, dwReturnValue
	ret
FS_IsPathRoot endp

;FS_CreateDirectoryEx
;	cool little function which will create a directory with subdirectories in it
;	normal CreateDirectory can only create the LAST level of the directory
;pszPath	= path to create; "X:\ABC\DEF\XYZ\somedir"
;		ABC, DEF, XYZ will be created along the way to create "somedir" :) :)
;
;NOTE: the check to see that an ABSOLUTE path was sent or relative path is not very stringent!!!
;	Have NOT checked that extensively!!!
FS_CreateDirectoryEx	proc	pszPath:LPCTSTR
	LOCAL	szTemp[MAX_PATH]:BYTE
	LOCAL	iSlashCount:SDWORD
	LOCAL	dwReturnValue:DWORD
	
	push	esi
	push	edi
	
	mov	dwReturnValue, FS_CDEX_FAILED

	mov	esi, pszPath
	lea	edi, szTemp
	
	;(weak?) check to see if the specified path is an ABSOLUTE PATH
	.if	byte ptr [esi+1] == ':'		;path starts at root, go till first '\'
		mov	iSlashCount, 0
		
		.while	byte ptr [esi] != 0
			.if	byte ptr [esi] == '\'
				inc	sdword ptr iSlashCount
			.endif
			.if	sdword ptr iSlashCount == 2
				.break
			.endif
			movsb
		.endw
	.endif
	
	.while	byte ptr [esi] != 0
		.if	byte ptr [esi] == '\'
			mov	byte ptr [edi], 0
			
			invoke	GetFileAttributes, addr szTemp
			.if	eax == INVALID_FILE_ATTRIBUTES
				;directory DOES NOT EXIST, try to create it !!!
				mov	dwReturnValue, FS_CDEX_CREATED	;assume operation succeeded
				
				invoke	CreateDirectory, addr szTemp, NULL
				.if	eax == 0
					mov	dwReturnValue, FS_CDEX_FAILED
					.break
				.endif
			.else
				;eax contains directory attributes
				test	eax, FILE_ATTRIBUTE_DIRECTORY
				.if	zero?	;probable file with that name exists :(
					mov	dwReturnValue, FS_CDEX_FAILED
					.break
				.endif
				
				;directory already exists, don't try to recreate it !!!
				mov	dwReturnValue, FS_CDEX_EXISTS
				;we are still in success mode :) :)
			.endif
		.endif
		movsb
	.endw
	
	;check how we have come out of the WHILE loop
	.if	dwReturnValue == FS_CDEX_FAILED
		mov	dwReturnValue, FS_CDEX_FAILED
		jmp	@f
	.endif
	
	;lets try to do the LAST operation, the final directory
	;the while ends with the LAST directory name still left to be created
	;SAME block as above 
	mov	byte ptr [edi], 0

	invoke	GetFileAttributes, addr szTemp
	.if	eax == INVALID_FILE_ATTRIBUTES
		;directory DOES NOT EXIST, try to create it !!!
		mov	dwReturnValue, FS_CDEX_CREATED	;assume operation succeeded
		
		invoke	CreateDirectory, addr szTemp, NULL
		.if	eax == 0
			mov	dwReturnValue, FS_CDEX_FAILED
		.endif
	.else
		;eax contains directory attributes
		test	eax, FILE_ATTRIBUTE_DIRECTORY
		.if	zero?	;probable file with that name exists :(
			mov	dwReturnValue, FS_CDEX_FAILED
		.endif
		
		;directory already exists, don't try to recreate it !!!
		mov	dwReturnValue, FS_CDEX_EXISTS
		;we are still in success mode :) :)
	.endif
@@:
	pop	edi
	pop	esi
	
	mov	eax, dwReturnValue
	ret
FS_CreateDirectoryEx	endp

end
